<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>World_OSI &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="EndToEnd Test Framework" href="../30_testing.html" />
    <link rel="prev" title="System Structure and Parameterization (SSP)" href="system_structure_and_parameterization_%28SSP%29.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../20_simulator_advanced.html">Simulator</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="agent_components.html">Agent Components</a></li>
<li class="toctree-l2"><a class="reference internal" href="coordinate_systems.html">Coordinate Systems</a></li>
<li class="toctree-l2"><a class="reference internal" href="event_detector.html">EventDetector</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenario_actions.html">Mapping of OpenSCENARIO Actions</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulation.html">Simulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="spawner_features.html">Spawner Features</a></li>
<li class="toctree-l2"><a class="reference internal" href="system_structure_and_parameterization_%28SSP%29.html">System Structure and Parameterization (SSP)</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">World_OSI</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#sampling-of-world-geometries">Sampling of World Geometries</a></li>
<li class="toctree-l3"><a class="reference internal" href="#localization">Localization</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#basics">Basics</a></li>
<li class="toctree-l4"><a class="reference internal" href="#localization-sequence">Localization Sequence</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#traffic-signs-road-markings-and-trafficlights">Traffic Signs, Road Markings and TrafficLights</a></li>
<li class="toctree-l3"><a class="reference internal" href="#lane-markings">Lane Markings</a></li>
<li class="toctree-l3"><a class="reference internal" href="#getobstruction">GetObstruction</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../20_simulator_advanced.html">Simulator</a></li>
      <li class="breadcrumb-item active">World_OSI</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/advanced_topics/simulator/world_osi.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="world-osi">
<span id="id1"></span><h1>World_OSI<a class="headerlink" href="#world-osi" title="Link to this heading"></a></h1>
<section id="sampling-of-world-geometries">
<span id="world-sampling"></span><h2>Sampling of World Geometries<a class="headerlink" href="#sampling-of-world-geometries" title="Link to this heading"></a></h2>
<p>Roads are described following the <a class="reference external" href="https://www.asam.net/standards/detail/opendrive/">OpenDRIVE</a> specification.
There the geometry of a road is defined algebraically as lines, clothoids and by means of cubic polynomials, whereby primarily only one reference line is defined.
The lanes can be understood as a stack of parallel lanes, which are given by the width and the offset, now in relation to this reference line, which acts as the underlying coordinate system (‘s/t’ road coordinates with s along the road).
Here, too, width and offset are defined algebraically, which means that almost any boundary lines can be defined.</p>
<p>When the world is initialized, these boundary definitions (i.e. algebraic geometries) are converted into piecewise linear elements, which is called sampling.
The road is scanned at a constant interval along ‘s’, which leads to four-sided (quadrangular) sections of the lanes at common ‘s’ coordinates, so-called lane elements (see LaneElement).
The scanning is carried out at a scanning rate of 10 centimeters with the aim of achieving a total scanning error of less than 5 centimeters, as required by the representation used internally (c.f. <a class="reference external" href="https://github.com/OpenSimulationInterface">open simulation interface</a>).
Note that this error is only guaranteed if geometries do not exhibit extreme curvatures, i.e. a deviation of more than 5 cm within two sampling points (10 cm along s).
The scanned points define so-called joints, which contain all scanned points at an ‘s’ coordinate across all lane boundaries of the given road.
The number of these joints is reduced by a <a class="reference external" href="https://en.wikipedia.org/wiki/Ramer%E2%80%93Douglas%E2%80%93Peucker_algorithm">Ramer-Douglas-Peucker algorithm</a>, which ensures that the maximum lateral error of each individual point within a joint is less than 5 cm compared to the originally scanned points.
Note that (a) the boundary points of geometries are always retained and (b) additional points for lane marking transitions are also retained to ensure the maximum accuracy of these edge cases.
The lane elements are generated with two successive connections, which are ultimately used in the localization at runtime (see <a class="reference internal" href="#world-localization"><span class="std std-ref">Localization</span></a>).</p>
<p>Internally, each lane element receives a constant direction, which is defined by the direction of the vector spanned between the centers of the corresponding connections.
Each joint also holds the corresponding curvature of the road, so that the curvature can be interpolated linearly within a lane element along the ‘s’ coordinate.</p>
</section>
<section id="localization">
<span id="world-localization"></span><h2>Localization<a class="headerlink" href="#localization" title="Link to this heading"></a></h2>
<p>Generally, the position of an agent is stored with respect to <a class="reference internal" href="coordinate_systems.html#coordinatesystems-world"><span class="std std-ref">world coordinates (x,y)</span></a>.
As queries on the world operates in <a class="reference internal" href="coordinate_systems.html#coordinatesystems-road"><span class="std std-ref">road coordinates (s,t)</span></a>, the position of the agent needs to be transformed.</p>
<p>This section describes the translation of coordinates (x,y) of an agent into RoadCoordinate (s,t), whereas the notion of (s,t) comes from the <cite>OpenDRIVE</cite> _ standard.</p>
<section id="basics">
<h3>Basics<a class="headerlink" href="#basics" title="Link to this heading"></a></h3>
<p>The following image depics the basic principes of the localization which is rooted on the specifics of the OSI World Layer (aka OWL).</p>
<figure class="align-default" id="id2">
<img alt="../../_images/LocalizationBasics.svg" src="../../_images/LocalizationBasics.svg" /><figcaption>
<p><span class="caption-text">Localization Basics</span><a class="headerlink" href="#id2" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>Given is a point P in cartesian coordinates (x/y).
The task is to assign the point to a lane, defined by a general road geometry and calculate the transformed Point P’ in road coordinates (s/t).</p>
<p>Road geometry (based on <a class="reference external" href="https://www.asam.net/standards/detail/opendrive/">OpenDRIVE</a>):</p>
<blockquote>
<div><ul class="simple">
<li><p>A road consists of several sections</p></li>
<li><p>Each section consists of several lanes</p></li>
<li><p>Within a section, the number of lanes is constant</p></li>
<li><p>Lanes can have one predecessor and one successor</p></li>
<li><p>The road follows a reference line, which is the reference for the <em>s</em>-coordinate.
The <em>t</em>-coordinate is perpendicular to this line.</p></li>
</ul>
</div></blockquote>
<p>OWL specifics:</p>
<blockquote>
<div><ul class="simple">
<li><p>All lanes are sampled, generating a stream of generic quadrilaterals (LaneGeometryElements).</p></li>
<li><p>Within a section, the number of quads per lane is equal, and all lanes have the same length in s.</p></li>
<li><p>This is realized by a variable sampling width, determined by a constant sampling width along the longest arc.</p></li>
<li><p>Consequently, points perpendicular to the reference line (<em>t</em>-axis) have the same <em>s</em>-coordinate.</p></li>
</ul>
</div></blockquote>
<p>Note, that the final <em>t</em>-coordinate is calculated with respect to a virtual reference line for each lane.
This means, that points on the center of a lane have <em>t</em>-coordinate of 0.</p>
</section>
<section id="localization-sequence">
<h3>Localization Sequence<a class="headerlink" href="#localization-sequence" title="Link to this heading"></a></h3>
<p>The following outlines the localization process implemented in openPASS, using a specific example of a bus changing lanes on a widening road.</p>
<figure class="align-default" id="id3">
<img alt="../../_images/localization_with_bus_step0.svg" src="../../_images/localization_with_bus_step0.svg" /><figcaption>
<p><span class="caption-text">Bus changing lanes on a widening road</span><a class="headerlink" href="#id3" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>First, as described above LaneGeometryElements are generated for the road, here shown as a simplified red grid:</p>
<figure class="align-default" id="id4">
<img alt="../../_images/localization_with_bus_step1.svg" src="../../_images/localization_with_bus_step1.svg" /><figcaption>
<p><span class="caption-text">LaneGeometryElements and bounding box of the bus</span><a class="headerlink" href="#id4" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>All geometries are internally managed by an <a class="reference external" href="https://www.boost.org/doc/libs/1_65_0/libs/geometry/doc/html/geometry/reference/spatial_indexes/boost__geometry__index__rtree.html">r-tree</a>, used to check for overlaps between the bounding box of the bus and all stored objects in the tree, making checks for overlap extremely fast.
However, the r-tree comes with the restriction that all stored objects are stored by boxes orthogonal to <code class="docutils literal notranslate"><span class="pre">x</span></code> and <code class="docutils literal notranslate"><span class="pre">y</span></code> (= maximum Cartesian coordinates of the boundary points).</p>
<figure class="align-default" id="id5">
<img alt="../../_images/localization_with_bus_step2.svg" src="../../_images/localization_with_bus_step2.svg" /><figcaption>
<p><span class="caption-text">r-Tree representation of the Bus and a single LaneGeometryElement</span><a class="headerlink" href="#id5" title="Link to this image"></a></p>
</figcaption>
</figure>
<figure class="align-default" id="id6">
<img alt="../../_images/localization_with_bus_step3.svg" src="../../_images/localization_with_bus_step3.svg" /><figcaption>
<p><span class="caption-text">r-Tree representation of all participating geometries</span><a class="headerlink" href="#id6" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>This introduces additional overlaps, resulting in false positives where the bus is located on segments it does not actually touch.</p>
<figure class="align-default" id="id7">
<img alt="../../_images/localization_with_bus_step4.svg" src="../../_images/localization_with_bus_step4.svg" /><figcaption>
<p><span class="caption-text">Found overlaps with false positives</span><a class="headerlink" href="#id7" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>This is justified because the subsequent filtering can be carried out quickly since the possible geometries allow a simplified intersection check.
Finally, for each point of a non-empty intersection polygon, the <code class="docutils literal notranslate"><span class="pre">s</span></code> and <code class="docutils literal notranslate"><span class="pre">t</span></code> coordinates are calculated and aggregated with respect to the underlying lane.
For each touched lane, the minimum and maximum <code class="docutils literal notranslate"><span class="pre">s</span></code> coordinate, and the minimum and maximum lane remainder (delta t) is stored.</p>
<figure class="align-default" id="id8">
<img alt="../../_images/localization_with_bus_step5.svg" src="../../_images/localization_with_bus_step5.svg" /><figcaption>
<p><span class="caption-text">Example for the calculation of s_min, s_max and delta_right</span><a class="headerlink" href="#id8" title="Link to this image"></a></p>
</figcaption>
</figure>
<p>In addition, if the reference point (i.e. the middle of the rear axle) or the mainLaneLocator (i.e. the middle of the agent front) are located within a LaneGeometryElement, <code class="docutils literal notranslate"><span class="pre">s/t/yaw</span></code> is calculated of each point, respectively.
Further aggregation is done with respect to each road by calculating the minimum and maximum <code class="docutils literal notranslate"><span class="pre">s</span></code> for each road the agent intersects with.
For the current route of an agent, the following information is stored: <code class="docutils literal notranslate"><span class="pre">s/t/yaw</span></code> of the reference point and mainLaneLocator on the route (roads along a route are not allowed to intersect), distance from the lane boundary to the left and right for the road(s) along the route, and OpenDRIVE Ids of the lanes on the route that the agent touches.
The results also holds information whether both the reference point and the mainLaneLocator lay on the route.
In the current implementation, these points must be located - otherwise the agent is despawened, as the agent cannot execute distance queries without a relation to its current route.</p>
</section>
</section>
<section id="traffic-signs-road-markings-and-trafficlights">
<span id="world-trafficsigns"></span><h2>Traffic Signs, Road Markings and TrafficLights<a class="headerlink" href="#traffic-signs-road-markings-and-trafficlights" title="Link to this heading"></a></h2>
<p>The world currently supports a variety of traffic signs, road markings and traffic lights.
All of these are defined in <a class="reference external" href="https://www.asam.net/standards/detail/opendrive/">OpenDRIVE</a> as “RoadSignal”.
At the moment it can interpret traffic signs and road markings according to the German regulations, US regulations, and China regulations and traffic lights according the the <a class="reference external" href="https://www.asam.net/standards/detail/opendrive/">OpenDRIVE</a> appendix.
Traffic signs can contain optional supplementary traffic signs. Supplementary signs are dependent on a main traffic sign and contain additional information.</p>
<p>For Germany the types are based on the StVO (see: <a class="reference external" href="https://www.bast.de/BASt_2017/DE/Verkehrstechnik/Fachthemen/v1-verkehrszeichen/vz-download.html">https://www.bast.de/BASt_2017/DE/Verkehrstechnik/Fachthemen/v1-verkehrszeichen/vz-download.html</a>).
The following traffic signs are supported for Germany:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>TrafficSign</p></th>
<th class="head"><p>Image</p></th>
<th class="head"><p>StVo Type</p></th>
<th class="head"><p>Subtype</p></th>
<th class="head"><p>Value and Units</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>GiveWay</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/GiveWay_205.svg"><img alt="../../_images/GiveWay_205.svg" src="../../_images/GiveWay_205.svg" width="400" /></a>
</figure>
</td>
<td><p>205</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>Stop</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/Stop_206.svg"><img alt="../../_images/Stop_206.svg" src="../../_images/Stop_206.svg" width="400" /></a>
</figure>
</td>
<td><p>206</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>DoNotEnter</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/DoNotEnter_267.svg"><img alt="../../_images/DoNotEnter_267.svg" src="../../_images/DoNotEnter_267.svg" width="400" /></a>
</figure>
</td>
<td><p>267</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>EnvironmentalZoneBegin</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/EnvironmentalZoneBegin_270.1.svg"><img alt="../../_images/EnvironmentalZoneBegin_270.1.svg" src="../../_images/EnvironmentalZoneBegin_270.1.svg" width="400" /></a>
</figure>
</td>
<td><p>270.1</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>EnvironmentalZoneEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/EnvironmentalZoneEnd_270.2.svg"><img alt="../../_images/EnvironmentalZoneEnd_270.2.svg" src="../../_images/EnvironmentalZoneEnd_270.2.svg" width="400" /></a>
</figure>
</td>
<td><p>270.2</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>MaximumSpeedLimit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/MaximumSpeedLimit_274-5.svg"><img alt="../../_images/MaximumSpeedLimit_274-5.svg" src="../../_images/MaximumSpeedLimit_274-5.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/MaximumSpeedLimit_274-130.svg"><img alt="../../_images/MaximumSpeedLimit_274-130.svg" src="../../_images/MaximumSpeedLimit_274-130.svg" width="400" /></a>
</figure>
</td>
<td><p>274</p></td>
<td><p>X</p></td>
<td><p>The subtype “X” is used to define the speedlimit in km/h.
Afterwards the world converts it to m/s.</p></td>
</tr>
<tr class="row-even"><td><p>SpeedLimitZoneBegin</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/SpeedLimitZoneBegin_274.1.svg"><img alt="../../_images/SpeedLimitZoneBegin_274.1.svg" src="../../_images/SpeedLimitZoneBegin_274.1.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/SpeedLimitZoneBegin_274.1-20.svg"><img alt="../../_images/SpeedLimitZoneBegin_274.1-20.svg" src="../../_images/SpeedLimitZoneBegin_274.1-20.svg" width="400" /></a>
</figure>
</td>
<td><p>274.1</p></td>
<td><p>-/20</p></td>
<td><p>The subtype is used to define the speedlimit in km/h.
Afterwards the world converts it to m/s.
No subtype = 30km/h, 20 = 20km/h</p></td>
</tr>
<tr class="row-odd"><td><p>SpeedLimitZoneEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/SpeedLimitZoneEnd_274.2.svg"><img alt="../../_images/SpeedLimitZoneEnd_274.2.svg" src="../../_images/SpeedLimitZoneEnd_274.2.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/SpeedLimitZoneEnd_274.2-20.svg"><img alt="../../_images/SpeedLimitZoneEnd_274.2-20.svg" src="../../_images/SpeedLimitZoneEnd_274.2-20.svg" width="400" /></a>
</figure>
</td>
<td><p>274.2</p></td>
<td><p>-/20</p></td>
<td><p>The subtype is used to define the speedlimit in km/h.
Afterwards the world converts it to m/s.
No subtype = 30km/h, 20 = 20km/h</p></td>
</tr>
<tr class="row-even"><td><p>MinimumSpeedLimit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/MinimumSpeedLimit_275.svg"><img alt="../../_images/MinimumSpeedLimit_275.svg" src="../../_images/MinimumSpeedLimit_275.svg" width="400" /></a>
</figure>
</td>
<td><p>275</p></td>
<td><p>X</p></td>
<td><p>The subtype is used to define the speedlimit in km/h.
Afterwards the world converts it to m/s.</p></td>
</tr>
<tr class="row-odd"><td><p>OvertakingBanBegin</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/OvertakingBanBegin_276.svg"><img alt="../../_images/OvertakingBanBegin_276.svg" src="../../_images/OvertakingBanBegin_276.svg" width="400" /></a>
</figure>
</td>
<td><p>276</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>OvertakingBanTrucksBegin</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/OvertakingBanTrucksBegin_277.svg"><img alt="../../_images/OvertakingBanTrucksBegin_277.svg" src="../../_images/OvertakingBanTrucksBegin_277.svg" width="400" /></a>
</figure>
</td>
<td><p>277</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>EndOfMaximumSpeedLimit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/EndOfMaximumSpeedLimit_278-5.svg"><img alt="../../_images/EndOfMaximumSpeedLimit_278-5.svg" src="../../_images/EndOfMaximumSpeedLimit_278-5.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/EndOfMaximumSpeedLimit_278-130.svg"><img alt="../../_images/EndOfMaximumSpeedLimit_278-130.svg" src="../../_images/EndOfMaximumSpeedLimit_278-130.svg" width="400" /></a>
</figure>
</td>
<td><p>278</p></td>
<td><p>X</p></td>
<td><p>The subtype “X” is used to define the speedlimit in km/h.
Afterwards the world converts it to m/s.</p></td>
</tr>
<tr class="row-even"><td><p>EndOfMinimumSpeedLimit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/EndOfMinimumSpeedLimit_279.svg"><img alt="../../_images/EndOfMinimumSpeedLimit_279.svg" src="../../_images/EndOfMinimumSpeedLimit_279.svg" width="400" /></a>
</figure>
</td>
<td><p>279</p></td>
<td><p>X</p></td>
<td><p>The subtype “X” is used to define the speedlimit in km/h.
Afterwards the world converts it to m/s.</p></td>
</tr>
<tr class="row-odd"><td><p>OvertakingBanEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/OvertakingBanEnd_280.svg"><img alt="../../_images/OvertakingBanEnd_280.svg" src="../../_images/OvertakingBanEnd_280.svg" width="400" /></a>
</figure>
</td>
<td><p>280</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>OvertakingBanTrucksEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/OvertakingBanTrucksEnd_281.svg"><img alt="../../_images/OvertakingBanTrucksEnd_281.svg" src="../../_images/OvertakingBanTrucksEnd_281.svg" width="400" /></a>
</figure>
</td>
<td><p>281</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>EndOffAllSpeedLimitsAndOvertakingRestrictions</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/EndOffAllSpeedLimitsAndOvertakingRestrictions_282.svg"><img alt="../../_images/EndOffAllSpeedLimitsAndOvertakingRestrictions_282.svg" src="../../_images/EndOffAllSpeedLimitsAndOvertakingRestrictions_282.svg" width="400" /></a>
</figure>
</td>
<td><p>282</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>RightOfWayNextIntersection</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/RightOfWayNextIntersection_301.svg"><img alt="../../_images/RightOfWayNextIntersection_301.svg" src="../../_images/RightOfWayNextIntersection_301.svg" width="400" /></a>
</figure>
</td>
<td><p>301</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>RightOfWayBegin</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/RightOfWayBegin_306.svg"><img alt="../../_images/RightOfWayBegin_306.svg" src="../../_images/RightOfWayBegin_306.svg" width="400" /></a>
</figure>
</td>
<td><p>306</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>RightOfWayEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/RightOfWayEnd_307.svg"><img alt="../../_images/RightOfWayEnd_307.svg" src="../../_images/RightOfWayEnd_307.svg" width="400" /></a>
</figure>
</td>
<td><p>307</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>TownBegin</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/TownBegin_310.svg"><img alt="../../_images/TownBegin_310.svg" src="../../_images/TownBegin_310.svg" width="400" /></a>
</figure>
</td>
<td><p>310</p></td>
<td></td>
<td><p>This sign contains a text describing the name of the town</p></td>
</tr>
<tr class="row-even"><td><p>TownEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/TownEnd_311.svg"><img alt="../../_images/TownEnd_311.svg" src="../../_images/TownEnd_311.svg" width="400" /></a>
</figure>
</td>
<td><p>311</p></td>
<td></td>
<td><p>This sign contains a text describing the name of the town</p></td>
</tr>
<tr class="row-odd"><td><p>TrafficCalmedDistrictBegin</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/TrafficCalmedDistrictBegin_325.1.svg"><img alt="../../_images/TrafficCalmedDistrictBegin_325.1.svg" src="../../_images/TrafficCalmedDistrictBegin_325.1.svg" width="400" /></a>
</figure>
</td>
<td><p>325.1</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>TrafficCalmedDistrictEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/TrafficCalmedDistrictEnd_325.2.svg"><img alt="../../_images/TrafficCalmedDistrictEnd_325.2.svg" src="../../_images/TrafficCalmedDistrictEnd_325.2.svg" width="400" /></a>
</figure>
</td>
<td><p>325.2</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>HighWayBegin</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/HighWayBegin_330.1.svg"><img alt="../../_images/HighWayBegin_330.1.svg" src="../../_images/HighWayBegin_330.1.svg" width="400" /></a>
</figure>
</td>
<td><p>330.1</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>HighWayEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/HighWayEnd_330.2.svg"><img alt="../../_images/HighWayEnd_330.2.svg" src="../../_images/HighWayEnd_330.2.svg" width="400" /></a>
</figure>
</td>
<td><p>330.2</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>HighWayExit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/HighWayExit_333.svg"><img alt="../../_images/HighWayExit_333.svg" src="../../_images/HighWayExit_333.svg" width="400" /></a>
</figure>
</td>
<td><p>333</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>AnnounceHighwayExit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnounceHighwayExit_448.svg"><img alt="../../_images/AnnounceHighwayExit_448.svg" src="../../_images/AnnounceHighwayExit_448.svg" width="400" /></a>
</figure>
</td>
<td><p>448</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>PreannounceHighwayExitDirections</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnounceHighwayExit_449.svg"><img alt="../../_images/AnnounceHighwayExit_449.svg" src="../../_images/AnnounceHighwayExit_449.svg" width="400" /></a>
</figure>
</td>
<td><p>449</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>HighwayExitPole</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/HighwayExitPole_450-50.svg"><img alt="../../_images/HighwayExitPole_450-50.svg" src="../../_images/HighwayExitPole_450-50.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/HighwayExitPole_450-51.svg"><img alt="../../_images/HighwayExitPole_450-51.svg" src="../../_images/HighwayExitPole_450-51.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/HighwayExitPole_450-52.svg"><img alt="../../_images/HighwayExitPole_450-52.svg" src="../../_images/HighwayExitPole_450-52.svg" width="400" /></a>
</figure>
</td>
<td><p>450</p></td>
<td><p>50/51/52</p></td>
<td><p>The subtype describes the distance to the highway exit in m.
50 = 100m, 51 = 200m, 52 = 300m</p></td>
</tr>
<tr class="row-odd"><td><p>AnnounceRightLaneEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnounceRightLaneEnd_531-10.svg"><img alt="../../_images/AnnounceRightLaneEnd_531-10.svg" src="../../_images/AnnounceRightLaneEnd_531-10.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnounceRightLaneEnd_531-11.svg"><img alt="../../_images/AnnounceRightLaneEnd_531-11.svg" src="../../_images/AnnounceRightLaneEnd_531-11.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnounceRightLaneEnd_531-12.svg"><img alt="../../_images/AnnounceRightLaneEnd_531-12.svg" src="../../_images/AnnounceRightLaneEnd_531-12.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnounceRightLaneEnd_531-13.svg"><img alt="../../_images/AnnounceRightLaneEnd_531-13.svg" src="../../_images/AnnounceRightLaneEnd_531-13.svg" width="400" /></a>
</figure>
</td>
<td><p>531</p></td>
<td><p>10/11/12/13</p></td>
<td><p>The subtype describes the number of continuing lanes after the right lane ends.
10 = 1 lane, 11 = 2 lanes, 12 = 3 lanes, 13 = 4 lanes</p></td>
</tr>
<tr class="row-even"><td><p>AnnounceLeftLaneEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnounceLeftLaneEnd_531-20.svg"><img alt="../../_images/AnnounceLeftLaneEnd_531-20.svg" src="../../_images/AnnounceLeftLaneEnd_531-20.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnounceLeftLaneEnd_531-21.svg"><img alt="../../_images/AnnounceLeftLaneEnd_531-21.svg" src="../../_images/AnnounceLeftLaneEnd_531-21.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnounceLeftLaneEnd_531-22.svg"><img alt="../../_images/AnnounceLeftLaneEnd_531-22.svg" src="../../_images/AnnounceLeftLaneEnd_531-22.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnounceLeftLaneEnd_531-23.svg"><img alt="../../_images/AnnounceLeftLaneEnd_531-23.svg" src="../../_images/AnnounceLeftLaneEnd_531-23.svg" width="400" /></a>
</figure>
</td>
<td><p>531</p></td>
<td><p>20/21/22/23</p></td>
<td><p>The subtype describes the number of continuing lanes after the left lane ends.
10 = 1 lane, 11 = 2 lanes, 12 = 3 lanes, 13 = 4 lanes</p></td>
</tr>
<tr class="row-odd"><td><p>DistanceIndication</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/DistanceIndication_1004-30.svg"><img alt="../../_images/DistanceIndication_1004-30.svg" src="../../_images/DistanceIndication_1004-30.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/DistanceIndication_1004-31.svg"><img alt="../../_images/DistanceIndication_1004-31.svg" src="../../_images/DistanceIndication_1004-31.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/DistanceIndication_1004-32.svg"><img alt="../../_images/DistanceIndication_1004-32.svg" src="../../_images/DistanceIndication_1004-32.svg" width="400" /></a>
</figure>
</td>
<td><p>1004</p></td>
<td><p>30/31/32</p></td>
<td><p>For subtype 30 the value describes the distance in m.
For subtype 31 the value describes the distance in km.
Subtype 32 has a STOP in 100m.</p></td>
</tr>
</tbody>
</table>
<p>The following road markings are supported for Germany:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>RoadMarking</p></th>
<th class="head"><p>Image</p></th>
<th class="head"><p>StVo Type</p></th>
<th class="head"><p>Subtype</p></th>
<th class="head"><p>Value and Units</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>PedestrianCrossing</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/PedestrianCrossing_293.svg"><img alt="../../_images/PedestrianCrossing_293.svg" src="../../_images/PedestrianCrossing_293.svg" width="400" /></a>
</figure>
</td>
<td><p>293</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>Stop line</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/Stop_line_294.svg"><img alt="../../_images/Stop_line_294.svg" src="../../_images/Stop_line_294.svg" width="400" /></a>
</figure>
</td>
<td><p>294</p></td>
<td></td>
<td></td>
</tr>
</tbody>
</table>
<p>The pedestrian crossing can also be defined in <a class="reference external" href="https://www.asam.net/standards/detail/opendrive/">OpenDRIVE</a> as object with type “crosswalk”.</p>
<p>For United States the types are based on the “Manual on Uniform Traffic Control Devices” (see: <a class="reference external" href="https://mutcd.fhwa.dot.gov/pdfs/2009r1r2/pdf_index.htm">https://mutcd.fhwa.dot.gov/pdfs/2009r1r2/pdf_index.htm</a>).
The following traffic signs are supported for United States:</p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>TrafficSign</p></th>
<th class="head"><p>Image</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Value and Units</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>HighWayExit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/HighWayExit_E5-1.svg"><img alt="../../_images/HighWayExit_E5-1.svg" src="../../_images/HighWayExit_E5-1.svg" width="400" /></a>
</figure>
</td>
<td><p>E5-1</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>HighWayExit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/HighWayExit_E2-5.svg"><img alt="../../_images/HighWayExit_E2-5.svg" src="../../_images/HighWayExit_E2-5.svg" width="400" /></a>
</figure>
</td>
<td><p>E2-5</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>AnnounceHighwayExit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnounceHighwayExit_E1-2.svg"><img alt="../../_images/AnnounceHighwayExit_E1-2.svg" src="../../_images/AnnounceHighwayExit_E1-2.svg" width="400" /></a>
</figure>
</td>
<td><p>E1-2</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>PreannounceHighwayExit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/PreannounceHighwayExit_E1-2a.svg"><img alt="../../_images/PreannounceHighwayExit_E1-2a.svg" src="../../_images/PreannounceHighwayExit_E1-2a.svg" width="400" /></a>
</figure>
</td>
<td><p>E1-2a</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>Stop</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/Stop_R1-1.svg"><img alt="../../_images/Stop_R1-1.svg" src="../../_images/Stop_R1-1.svg" width="400" /></a>
</figure>
</td>
<td><p>R1-1</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>GiveWay</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/GiveWay_R1-2.svg"><img alt="../../_images/GiveWay_R1-2.svg" src="../../_images/GiveWay_R1-2.svg" width="400" /></a>
</figure>
</td>
<td><p>R1-2</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>MaximumSpeedLimit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/MaximumSpeedLimit_R2-1.svg"><img alt="../../_images/MaximumSpeedLimit_R2-1.svg" src="../../_images/MaximumSpeedLimit_R2-1.svg" width="400" /></a>
</figure>
</td>
<td><p>R2-1</p></td>
<td><p>as defined via the “value” and “unit” attributes</p></td>
</tr>
<tr class="row-odd"><td><p>DoNotPass (OvertakingBan)</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/DoNotPass_R4-1.svg"><img alt="../../_images/DoNotPass_R4-1.svg" src="../../_images/DoNotPass_R4-1.svg" width="400" /></a>
</figure>
</td>
<td><p>R4-1</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>DoNotEnter</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/DoNotEnter_R5-1.svg"><img alt="../../_images/DoNotEnter_R5-1.svg" src="../../_images/DoNotEnter_R5-1.svg" width="400" /></a>
</figure>
</td>
<td><p>R5-1</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>RightLaneEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/RightLaneEnd_W4-2R.svg"><img alt="../../_images/RightLaneEnd_W4-2R.svg" src="../../_images/RightLaneEnd_W4-2R.svg" width="400" /></a>
</figure>
</td>
<td><p>W4-2R</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>LeftLaneEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/LeftLaneEnd_W4-2L.svg"><img alt="../../_images/LeftLaneEnd_W4-2L.svg" src="../../_images/LeftLaneEnd_W4-2L.svg" width="400" /></a>
</figure>
</td>
<td><p>W4-2L</p></td>
<td></td>
</tr>
</tbody>
</table>
<p>For China the types are based on the <a class="reference external" href="https://upload.wikimedia.org/wikipedia/commons/8/8c/China_GB_5768.2-2009.pdf">https://upload.wikimedia.org/wikipedia/commons/8/8c/China_GB_5768.2-2009.pdf</a>.
The following traffic signs are supported for China:</p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>TrafficSign</p></th>
<th class="head"><p>Image</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Subtype</p></th>
<th class="head"><p>Value and Units</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>AnnounceRightLaneEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/EndofLaneRight-32a.svg"><img alt="../../_images/EndofLaneRight-32a.svg" src="../../_images/EndofLaneRight-32a.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/EndofLaneRight-32b.svg"><img alt="../../_images/EndofLaneRight-32b.svg" src="../../_images/EndofLaneRight-32b.svg" width="400" /></a>
</figure>
</td>
<td><p>EndofLane-32</p></td>
<td><p>a/b</p></td>
<td><p>The subtype describes the number of continuing lanes after the right lane ends.
a = 2 lanes, b = 3 lanes</p></td>
</tr>
<tr class="row-odd"><td><p>AnnounceLeftLaneEnd</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/EndofLaneLeft-32c.svg"><img alt="../../_images/EndofLaneLeft-32c.svg" src="../../_images/EndofLaneLeft-32c.svg" width="400" /></a>
</figure>
<figure class="align-default">
<a class="reference internal image-reference" href="../../_images/EndofLaneLeft-32d.svg"><img alt="../../_images/EndofLaneLeft-32d.svg" src="../../_images/EndofLaneLeft-32d.svg" width="400" /></a>
</figure>
</td>
<td><p>EndofLane-32</p></td>
<td><p>c/d</p></td>
<td><p>The subtype describes the number of continuing lanes after the left lane ends.
c = 2 lanes, d = 3 lanes</p></td>
</tr>
<tr class="row-even"><td><p>MaximumSpeedLimit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/MaximumSpeedLimit-38.svg"><img alt="../../_images/MaximumSpeedLimit-38.svg" src="../../_images/MaximumSpeedLimit-38.svg" width="400" /></a>
</figure>
</td>
<td><p>SpeedLimit-38</p></td>
<td></td>
<td><p>as defined via the “value” and “unit” attributes</p></td>
</tr>
<tr class="row-odd"><td><p>EndOfMaximumSpeedLimit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/EndOfMaximumSpeedLimit-39.svg"><img alt="../../_images/EndOfMaximumSpeedLimit-39.svg" src="../../_images/EndOfMaximumSpeedLimit-39.svg" width="400" /></a>
</figure>
</td>
<td><p>EndOfSpeedLimit-39</p></td>
<td></td>
<td><p>as defined via the “value” and “unit” attributes</p></td>
</tr>
<tr class="row-even"><td><p>AnnounceHighwayExit (1km)</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnouceHighwayExit1km-50b.svg"><img alt="../../_images/AnnouceHighwayExit1km-50b.svg" src="../../_images/AnnouceHighwayExit1km-50b.svg" width="400" /></a>
</figure>
</td>
<td><p>AnnounceHighwayExit-50b</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>AnnounceHighwayExit (500m)</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/AnnouceHighwayExit500m-50c.svg"><img alt="../../_images/AnnouceHighwayExit500m-50c.svg" src="../../_images/AnnouceHighwayExit500m-50c.svg" width="400" /></a>
</figure>
</td>
<td><p>AnnounceHighwayExit-50c</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>HighWayExit</p></td>
<td><figure class="align-default">
<a class="reference internal image-reference" href="../../_images/HighwayExit-50d.svg"><img alt="../../_images/HighwayExit-50d.svg" src="../../_images/HighwayExit-50d.svg" width="400" /></a>
</figure>
</td>
<td><p>HighwayExit-50d</p></td>
<td></td>
<td></td>
</tr>
</tbody>
</table>
<p>The following traffic lights are supported:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>TrafficLight</p></th>
<th class="head"><p>OpenDRIVE Type</p></th>
<th class="head"><p>Subtype</p></th>
<th class="head"><p>Value and Units</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>Standard traffic light (red, yellow, green)</p></td>
<td><p>1.000.001</p></td>
<td><p>-</p></td>
<td><p>-</p></td>
</tr>
<tr class="row-odd"><td><p>Left arrows</p></td>
<td><p>1.000.011</p></td>
<td><p>10</p></td>
<td><p>-</p></td>
</tr>
<tr class="row-even"><td><p>Right arrows</p></td>
<td><p>1.000.011</p></td>
<td><p>20</p></td>
<td><p>-</p></td>
</tr>
<tr class="row-odd"><td><p>Upwards arrows</p></td>
<td><p>1.000.011</p></td>
<td><p>30</p></td>
<td><p>-</p></td>
</tr>
<tr class="row-even"><td><p>Left und upwards arrows</p></td>
<td><p>1.000.011</p></td>
<td><p>40</p></td>
<td><p>-</p></td>
</tr>
<tr class="row-odd"><td><p>Right und upwards arrows</p></td>
<td><p>1.000.011</p></td>
<td><p>50</p></td>
<td><p>-</p></td>
</tr>
</tbody>
</table>
<p>These traffic lights are controlled by <a class="reference external" href="https://www.asam.net/standards/detail/openscenario/">OpenSCENARIO</a>.</p>
</section>
<section id="lane-markings">
<span id="world-lanemarkings"></span><h2>Lane Markings<a class="headerlink" href="#lane-markings" title="Link to this heading"></a></h2>
<p>The world also supports lane markings (i.e. printed lines between two lanes) according to the <a class="reference external" href="https://www.asam.net/standards/detail/opendrive/">OpenDRIVE</a> standard.
The following attributes of the “roadMark” tag in the scenery file are stored in the world and can be retrieved by the GetLaneMarkings query: sOffset, type, weight, color.
The weight is converted into a width in meter: 0.15 for standard and 0.3 for bold. Lane markings are also converted to OSI LaneBoundaries.
For the OpenDRIVE type “solid solid”, “solid broken”, “broken solid”, and “broken broken” two LaneBoundaries are created in OSI with a fixed lateral distance of 0.15m.</p>
</section>
<section id="getobstruction">
<span id="world-getobstruction"></span><h2>GetObstruction<a class="headerlink" href="#getobstruction" title="Link to this heading"></a></h2>
<p>The GetObstruction function calculates the lateral distance an agent must travel in order to align with either the left or right boundary of a target object occupying the same lane.</p>
<p>The calculation adheres to the following process:</p>
<ol class="arabic simple">
<li><p>Project the agent’s MainLaneLocator along the lane to the nearest and furthest s-coordinate of the target object, capturing the projected points</p></li>
<li><p>Create a straight line from the two captured points</p></li>
<li><p>Calculate the Euclidean distance of each of the target object’s corners to the created line</p></li>
<li><p>Return the left-most and right-most points with respect to the created line</p></li>
</ol>
<p>If the first step fails, because the ego lane does not extend to the object’s position (i.e. it ends prematurely or the objects is outside the ego’s route), then the result is invalid, which is indicated by a separate valid flag.</p>
<figure class="align-default" id="id9">
<img alt="../../_images/GetObstruction.svg" src="../../_images/GetObstruction.svg" /><figcaption>
<p><span class="caption-text">Example for the calculation of GetObstruction</span><a class="headerlink" href="#id9" title="Link to this image"></a></p>
</figcaption>
</figure>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="system_structure_and_parameterization_%28SSP%29.html" class="btn btn-neutral float-left" title="System Structure and Parameterization (SSP)" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="../30_testing.html" class="btn btn-neutral float-right" title="EndToEnd Test Framework" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>